diff --git a/gcc/config/avr/avr.c b/gcc/config/avr/avr.c
index 8ca7de0..db791d3 100644
--- a/gcc/config/avr/avr.c
+++ b/gcc/config/avr/avr.c
@@ -290,7 +290,7 @@ avr_to_int_mode (rtx x)
 static void
 avr_option_override (void)
 {
-  flag_delete_null_pointer_checks = 0;
+  GCC_OPTION (flag_delete_null_pointer_checks) = 0;
 
   /* caller-save.c looks for call-clobbered hard registers that are assigned
      to pseudos that cross calls and tries so save-restore them around calls
@@ -300,30 +300,30 @@ avr_option_override (void)
      with the challenge of AVR's very few address registers and fails to
      perform the requested spills.  */
 
-  if (avr_strict_X)
-    flag_caller_saves = 0;
+  if (GCC_OPTION (avr_strict_X))
+    GCC_OPTION (flag_caller_saves) = 0;
 
   /* Unwind tables currently require a frame pointer for correctness,
      see toplev.c:process_options().  */
 
-  if ((flag_unwind_tables
-       || flag_non_call_exceptions
-       || flag_asynchronous_unwind_tables)
+  if ((GCC_OPTION (flag_unwind_tables)
+       || GCC_OPTION (flag_non_call_exceptions)
+       || GCC_OPTION (flag_asynchronous_unwind_tables))
       && !ACCUMULATE_OUTGOING_ARGS)
     {
-      flag_omit_frame_pointer = 0;
+      GCC_OPTION (flag_omit_frame_pointer) = 0;
     }
 
-  if (flag_pic == 1)
+  if (GCC_OPTION (flag_pic) == 1)
     warning (OPT_fpic, "-fpic is not supported");
-  if (flag_pic == 2)
+  if (GCC_OPTION (flag_pic) == 2)
     warning (OPT_fPIC, "-fPIC is not supported");
-  if (flag_pie == 1)
+  if (GCC_OPTION (flag_pie) == 1)
     warning (OPT_fpie, "-fpie is not supported");
-  if (flag_pie == 2)
+  if (GCC_OPTION (flag_pie) == 2)
     warning (OPT_fPIE, "-fPIE is not supported");
 
-  avr_current_device = &avr_mcu_types[avr_mcu_index];
+  avr_current_device = &avr_mcu_types[GCC_OPTION (avr_mcu_index)];
   avr_current_arch = &avr_arch_types[avr_current_device->arch];
 
   /* RAM addresses of some SFRs common to all devices in respective arch. */
@@ -1354,7 +1354,7 @@ avr_expand_prologue (void)
 
   avr_prologue_setup_frame (size, set);
 
-  if (flag_stack_usage_info)
+  if (GCC_OPTION (flag_stack_usage_info))
     current_function_static_stack_size = cfun->machine->stack_usage;
 }
 
@@ -3241,7 +3241,7 @@ out_movqi_r_mr (rtx insn, rtx op[], int *plen)
 
   if (CONSTANT_ADDRESS_P (x))
     {
-      return optimize > 0 && io_address_operand (x, QImode)
+      return GCC_OPTION (optimize) > 0 && io_address_operand (x, QImode)
         ? avr_asm_len ("in %0,%i1", op, plen, -1)
         : avr_asm_len ("lds %0,%m1", op, plen, -2);
     }
@@ -3400,7 +3400,7 @@ out_movhi_r_mr (rtx insn, rtx op[], int *plen)
     }
   else if (CONSTANT_ADDRESS_P (base))
     {
-      return optimize > 0 && io_address_operand (base, HImode)
+      return GCC_OPTION (optimize) > 0 && io_address_operand (base, HImode)
         ? avr_asm_len ("in %A0,%i1" CR_TAB
                        "in %B0,%i1+1", op, plen, -2)
 
@@ -4101,7 +4101,7 @@ out_movqi_mr_r (rtx insn, rtx op[], int *plen)
 
   if (CONSTANT_ADDRESS_P (x))
     {
-      return optimize > 0 && io_address_operand (x, QImode)
+      return GCC_OPTION (optimize) > 0 && io_address_operand (x, QImode)
         ? avr_asm_len ("out %i0,%1", op, plen, -1)
         : avr_asm_len ("sts %m0,%1", op, plen, -2);
     }
@@ -4173,7 +4173,7 @@ avr_out_movhi_mr_r_xmega (rtx insn, rtx op[], int *plen)
   int mem_volatile_p = MEM_VOLATILE_P (dest);
 
   if (CONSTANT_ADDRESS_P (base))
-    return optimize > 0 && io_address_operand (base, HImode)
+    return GCC_OPTION (optimize) > 0 && io_address_operand (base, HImode)
       ? avr_asm_len ("out %i0,%A1" CR_TAB
                      "out %i0+1,%B1", op, plen, -2)
 
@@ -4288,7 +4288,7 @@ out_movhi_mr_r (rtx insn, rtx op[], int *plen)
   mem_volatile_p = MEM_VOLATILE_P (dest);
 
   if (CONSTANT_ADDRESS_P (base))
-    return optimize > 0 && io_address_operand (base, HImode)
+    return GCC_OPTION (optimize) > 0 && io_address_operand (base, HImode)
       ? avr_asm_len ("out %i0+1,%B1" CR_TAB
                      "out %i0,%A1", op, plen, -2)
 
@@ -4746,7 +4746,7 @@ out_shift_with_cnt (const char *templ, rtx insn, rtx operands[],
       if (count < 8 && !scratch)
         use_zero_reg = true;
 
-      if (optimize_size)
+      if (GCC_OPTION (optimize_size))
         max_len = t_len + (scratch ? 3 : (use_zero_reg ? 4 : 5));
 
       if (t_len * count <= max_len)
@@ -4951,7 +4951,7 @@ ashlhi3_out (rtx insn, rtx operands[], int *len)
 		  "clr %A0");
 
 	case 4:
-	  if (optimize_size && scratch)
+	  if (GCC_OPTION (optimize_size) && scratch)
 	    break;  /* 5 */
 	  if (ldi_ok)
 	    {
@@ -4977,7 +4977,7 @@ ashlhi3_out (rtx insn, rtx operands[], int *len)
 	  break;  /* optimize_size ? 6 : 8 */
 
 	case 5:
-	  if (optimize_size)
+	  if (GCC_OPTION (optimize_size))
 	    break;  /* scratch ? 5 : 6 */
 	  if (ldi_ok)
 	    {
@@ -5007,7 +5007,7 @@ ashlhi3_out (rtx insn, rtx operands[], int *len)
 	  break;  /* 10 */
 
 	case 6:
-	  if (optimize_size)
+	  if (GCC_OPTION (optimize_size))
 	    break;  /* scratch ? 5 : 6 */
 	  *len = 9;
 	  return ("clr __tmp_reg__" CR_TAB
@@ -5098,7 +5098,7 @@ ashlhi3_out (rtx insn, rtx operands[], int *len)
 		      "clr %A0"     CR_TAB
 		      "clr __zero_reg__");
 	    }
-	  if (optimize_size && scratch)
+	  if (GCC_OPTION (optimize_size) && scratch)
 	    break;  /* 5 */
 	  if (scratch)
 	    {
@@ -5148,7 +5148,7 @@ ashlhi3_out (rtx insn, rtx operands[], int *len)
 		      "clr %A0"     CR_TAB
 		      "clr __zero_reg__");
 	    }
-	  if (optimize_size && ldi_ok)
+	  if (GCC_OPTION (optimize_size) && ldi_ok)
 	    {
 	      *len = 5;
 	      return ("mov %B0,%A0" CR_TAB
@@ -5157,7 +5157,7 @@ ashlhi3_out (rtx insn, rtx operands[], int *len)
 		      "dec %A0"     CR_TAB
 		      "brne 1b");
 	    }
-	  if (optimize_size && scratch)
+	  if (GCC_OPTION (optimize_size) && scratch)
 	    break;  /* 5 */
 	  *len = 6;
 	  return ("clr %B0" CR_TAB
@@ -5429,7 +5429,7 @@ ashrhi3_out (rtx insn, rtx operands[], int *len)
 	  break;
 
 	case 6:
-	  if (optimize_size)
+	  if (GCC_OPTION (optimize_size))
 	    break;  /* scratch ? 5 : 6 */
 	  *len = 8;
 	  return ("mov __tmp_reg__,%A0" CR_TAB
@@ -5489,7 +5489,7 @@ ashrhi3_out (rtx insn, rtx operands[], int *len)
 		      "sbc %B0,%B0"  CR_TAB
 		      "clr __zero_reg__");
 	    }
-	  if (optimize_size && scratch)
+	  if (GCC_OPTION (optimize_size) && scratch)
 	    break;  /* 5 */
 	  *len = 6;
 	  return ("mov %A0,%B0" CR_TAB
@@ -5509,7 +5509,7 @@ ashrhi3_out (rtx insn, rtx operands[], int *len)
 		      "sbc %B0,%B0"  CR_TAB
 		      "clr __zero_reg__");
 	    }
-	  if (optimize_size && scratch)
+	  if (GCC_OPTION (optimize_size) && scratch)
 	    break;  /* 5 */
 	  *len = 7;
 	  return ("mov %A0,%B0" CR_TAB
@@ -5530,7 +5530,7 @@ ashrhi3_out (rtx insn, rtx operands[], int *len)
 		      "sbc %B0,%B0"  CR_TAB
 		      "clr __zero_reg__");
 	    }
-	  if (optimize_size)
+	  if (GCC_OPTION (optimize_size))
 	    break;  /* scratch ? 5 : 7 */
 	  *len = 8;
 	  return ("mov %A0,%B0" CR_TAB
@@ -5846,7 +5846,7 @@ lshrhi3_out (rtx insn, rtx operands[], int *len)
 		  "clr %A0");
 
 	case 4:
-	  if (optimize_size && scratch)
+	  if (GCC_OPTION (optimize_size) && scratch)
 	    break;  /* 5 */
 	  if (ldi_ok)
 	    {
@@ -5872,7 +5872,7 @@ lshrhi3_out (rtx insn, rtx operands[], int *len)
 	  break;  /* optimize_size ? 6 : 8 */
 
 	case 5:
-	  if (optimize_size)
+	  if (GCC_OPTION (optimize_size))
 	    break;  /* scratch ? 5 : 6 */
 	  if (ldi_ok)
 	    {
@@ -5902,7 +5902,7 @@ lshrhi3_out (rtx insn, rtx operands[], int *len)
 	  break;  /* 10 */
 
 	case 6:
-	  if (optimize_size)
+	  if (GCC_OPTION (optimize_size))
 	    break;  /* scratch ? 5 : 6 */
 	  *len = 9;
 	  return ("clr __tmp_reg__" CR_TAB
@@ -5993,7 +5993,7 @@ lshrhi3_out (rtx insn, rtx operands[], int *len)
 		      "clr %B0"     CR_TAB
 		      "clr __zero_reg__");
 	    }
-	  if (optimize_size && scratch)
+	  if (GCC_OPTION (optimize_size) && scratch)
 	    break;  /* 5 */
 	  if (scratch)
 	    {
@@ -6043,7 +6043,7 @@ lshrhi3_out (rtx insn, rtx operands[], int *len)
 		      "clr %B0"     CR_TAB
 		      "clr __zero_reg__");
 	    }
-	  if (optimize_size && ldi_ok)
+	  if (GCC_OPTION (optimize_size) && ldi_ok)
 	    {
 	      *len = 5;
 	      return ("mov %A0,%B0" CR_TAB
@@ -6052,7 +6052,7 @@ lshrhi3_out (rtx insn, rtx operands[], int *len)
 		      "dec %B0"     CR_TAB
 		      "brne 1b");
 	    }
-	  if (optimize_size && scratch)
+	  if (GCC_OPTION (optimize_size) && scratch)
 	    break;  /* 5 */
 	  *len = 6;
 	  return ("clr %A0" CR_TAB
@@ -7001,7 +7001,7 @@ avr_out_addto_sp (rtx *op, int *plen)
 
   if (addend < 0)
     {
-      if (flag_verbose_asm || flag_print_asm_name)
+      if (GCC_OPTION (flag_verbose_asm) || GCC_OPTION (flag_print_asm_name))
         avr_asm_len (ASM_COMMENT_START "SP -= %n0", op, plen, 0);
 
       while (addend <= -pc_len)
@@ -7015,7 +7015,7 @@ avr_out_addto_sp (rtx *op, int *plen)
     }
   else if (addend > 0)
     {
-      if (flag_verbose_asm || flag_print_asm_name)
+      if (GCC_OPTION (flag_verbose_asm) || GCC_OPTION (flag_print_asm_name))
         avr_asm_len (ASM_COMMENT_START "SP += %0", op, plen, 0);
 
       while (addend-- > 0)
@@ -8462,11 +8462,11 @@ avr_asm_function_rodata_section (tree decl)
      but treat function-associated data-like jump tables as code
      rather than as user defined data.  AVR has no constant pools.  */
   {
-    int fdata = flag_data_sections;
+    int fdata = GCC_OPTION (flag_data_sections);
 
-    flag_data_sections = flag_function_sections;
+    GCC_OPTION (flag_data_sections) = GCC_OPTION (flag_function_sections);
     frodata = default_function_rodata_section (decl);
-    flag_data_sections = fdata;
+    GCC_OPTION (flag_data_sections) = fdata;
     flags = frodata->common.flags;
   }
 
@@ -9706,7 +9706,7 @@ avr_address_cost (rtx x, enum machine_mode mode ATTRIBUTE_UNUSED,
     }
   else if (CONSTANT_ADDRESS_P (x))
     {
-      if (optimize > 0
+      if (GCC_OPTION (optimize) > 0
           && io_address_operand (x, QImode))
         cost = 2;
     }
@@ -9981,7 +9981,7 @@ avr_reorg (void)
       if (!pattern)
         continue;
 
-      if (optimize
+      if (GCC_OPTION (optimize)
           && avr_reorg_remove_redundant_compare (insn))
         {
           continue;
@@ -10250,7 +10250,7 @@ avr_mode_code_base_reg_class (enum machine_mode mode ATTRIBUTE_UNUSED,
       return POINTER_Z_REGS;
     }
 
-  if (!avr_strict_X)
+  if (!GCC_OPTION (avr_strict_X))
     return reload_completed ? BASE_POINTER_REGS : POINTER_REGS;
 
   return PLUS == outer_code ? BASE_POINTER_REGS : POINTER_REGS;
@@ -10310,7 +10310,7 @@ avr_regno_mode_code_ok_for_base_p (int regno,
         }
     }
 
-  if (avr_strict_X
+  if (GCC_OPTION (avr_strict_X)
       && PLUS == outer_code
       && regno == REG_X)
     {
@@ -11080,7 +11080,7 @@ avr_convert_to_type (tree type, tree expr)
             code with progmem and pgm_read_xxx.
   */
 
-  if (avr_warn_addr_space_convert
+  if (GCC_OPTION (avr_warn_addr_space_convert)
       && expr != error_mark_node
       && POINTER_TYPE_P (type)
       && POINTER_TYPE_P (TREE_TYPE (expr)))
@@ -11651,7 +11651,7 @@ avr_out_insert_bits (rtx *op, int *plen)
 
   if (plen)
     *plen = 0;
-  else if (flag_print_asm_name)
+  else if (GCC_OPTION (flag_print_asm_name))
     fprintf (asm_out_file, ASM_COMMENT_START "map = 0x%08x\n", map);
 
   /* If MAP has fixed points it might be better to initialize the result
@@ -12169,7 +12169,7 @@ avr_fold_builtin (tree fndecl, int n_args ATTRIBUTE_UNUSED, tree *arg,
   unsigned int fcode = DECL_FUNCTION_CODE (fndecl);
   tree val_type = TREE_TYPE (TREE_TYPE (fndecl));
 
-  if (!optimize)
+  if (!GCC_OPTION (optimize))
     return NULL_TREE;
 
   switch (fcode)
diff --git a/gcc/config/avr/avr.h b/gcc/config/avr/avr.h
index 74be83c..6445703 100644
--- a/gcc/config/avr/avr.h
+++ b/gcc/config/avr/avr.h
@@ -89,9 +89,9 @@ enum
    there is always __AVR_SP8__ == __AVR_HAVE_8BIT_SP__.  */
 
 #define AVR_HAVE_8BIT_SP                                                \
-  (avr_current_device->short_sp || TARGET_TINY_STACK || avr_sp8)
+  (avr_current_device->short_sp || TARGET_TINY_STACK || GCC_OPTION (avr_sp8))
 
-#define AVR_HAVE_SPH (!avr_sp8)
+#define AVR_HAVE_SPH (!GCC_OPTION (avr_sp8))
 
 #define AVR_2_BYTE_PC (!AVR_HAVE_EIJMP_EICALL)
 #define AVR_3_BYTE_PC (AVR_HAVE_EIJMP_EICALL)
@@ -355,7 +355,7 @@ typedef struct avr_args
       }                                                                 \
   } while (0)
 
-#define BRANCH_COST(speed_p, predictable_p) avr_branch_cost
+#define BRANCH_COST(speed_p, predictable_p) GCC_OPTION (avr_branch_cost)
 
 #define SLOW_BYTE_ACCESS 0
 
diff --git a/gcc/config/bfin/bfin-opts.h b/gcc/config/bfin/bfin-opts.h
index b7cb39e..81ec1bb 100644
--- a/gcc/config/bfin/bfin-opts.h
+++ b/gcc/config/bfin/bfin-opts.h
@@ -21,7 +21,7 @@
 #define BFIN_OPTS_H
 
 /* CPU type.  */
-typedef enum bfin_cpu_type
+typedef enum GCC_OPTION (bfin_cpu_type)
 {
   BFIN_CPU_UNKNOWN,
   BFIN_CPU_BF512,
diff --git a/gcc/config/bfin/bfin-protos.h b/gcc/config/bfin/bfin-protos.h
index be26ad1..8c4f8d7 100644
--- a/gcc/config/bfin/bfin-protos.h
+++ b/gcc/config/bfin/bfin-protos.h
@@ -25,43 +25,43 @@
 /* For the anomaly 05-00-0245 */
 #define WA_SPECULATIVE_LOADS 0x00000001
 #define ENABLE_WA_SPECULATIVE_LOADS \
-  (bfin_workarounds & WA_SPECULATIVE_LOADS)
+  (GCC_OPTION (bfin_workarounds) & WA_SPECULATIVE_LOADS)
 
 /* For the anomaly 05-00-0244 */
 #define WA_SPECULATIVE_SYNCS 0x00000002
 #define ENABLE_WA_SPECULATIVE_SYNCS \
-  (bfin_workarounds & WA_SPECULATIVE_SYNCS)
+  (GCC_OPTION (bfin_workarounds) & WA_SPECULATIVE_SYNCS)
 
 /* For the anomaly 05-00-0371 */
 #define WA_RETS 0x00000004
 #define ENABLE_WA_RETS \
-  (bfin_workarounds & WA_RETS)
+  (GCC_OPTION (bfin_workarounds) & WA_RETS)
 
 /* For the anomaly 05-00-0426 */
 #define WA_INDIRECT_CALLS 0x00000008
 #define ENABLE_WA_INDIRECT_CALLS \
-  ((bfin_workarounds & WA_INDIRECT_CALLS) && !TARGET_ICPLB)
+  ((GCC_OPTION (bfin_workarounds) & WA_INDIRECT_CALLS) && !TARGET_ICPLB)
 
 #define WA_05000257 0x00000010
 #define ENABLE_WA_05000257 \
-  (bfin_workarounds & WA_05000257)
+  (GCC_OPTION (bfin_workarounds) & WA_05000257)
 
 #define WA_05000283 0x00000020
 #define ENABLE_WA_05000283 \
-  (bfin_workarounds & WA_05000283)
+  (GCC_OPTION (bfin_workarounds) & WA_05000283)
 
 #define WA_05000315 0x00000040
 #define ENABLE_WA_05000315 \
-  (bfin_workarounds & WA_05000315)
+  (GCC_OPTION (bfin_workarounds) & WA_05000315)
 
 /* For the anomaly 05-00-0312 */
 #define WA_LOAD_LCREGS 0x00000080
 #define ENABLE_WA_LOAD_LCREGS \
-  (bfin_workarounds & WA_LOAD_LCREGS)
+  (GCC_OPTION (bfin_workarounds) & WA_LOAD_LCREGS)
 
 #define WA_05000074 0x00000100
 #define ENABLE_WA_05000074 \
-  (bfin_workarounds & WA_05000074)
+  (GCC_OPTION (bfin_workarounds) & WA_05000074)
 
 extern bool function_arg_regno_p (int);
 
diff --git a/gcc/config/bfin/bfin.c b/gcc/config/bfin/bfin.c
index 8b28211..a22778d 100644
--- a/gcc/config/bfin/bfin.c
+++ b/gcc/config/bfin/bfin.c
@@ -1053,7 +1053,7 @@ bfin_load_pic_reg (rtx dest)
       
   if (global_options_set.x_bfin_library_id)
     addr = plus_constant (Pmode, pic_offset_table_rtx,
-			   -4 - bfin_library_id * 4);
+			   -4 - GCC_OPTION (bfin_library_id) * 4);
   else
     addr = gen_rtx_PLUS (Pmode, pic_offset_table_rtx,
 			 gen_rtx_UNSPEC (Pmode, gen_rtvec (1, const0_rtx),
@@ -2006,7 +2006,7 @@ bfin_longcall_p (rtx op, int call_cookie)
     return 0;
   if (call_cookie & CALL_LONG)
     return 1;
-  if (TARGET_LONG_CALLS)
+  if (GCC_OPTION (TARGET_LONG_CALLS))
     return 1;
   return 0;
 }
@@ -2031,7 +2031,7 @@ bfin_expand_call (rtx retval, rtx fnaddr, rtx callarg1, rtx cookie, int sibcall)
     cookie = const0_rtx;
 
   /* Static functions and indirect calls don't need the pic register.  */
-  if (!TARGET_FDPIC && flag_pic
+  if (!TARGET_FDPIC && GCC_OPTION (flag_pic)
       && GET_CODE (callee) == SYMBOL_REF
       && !SYMBOL_REF_LOCAL_P (callee))
     use_reg (&use, pic_offset_table_rtx);
@@ -2167,7 +2167,7 @@ bfin_register_move_cost (enum machine_mode mode,
     return 4;
 
   /* If optimizing for size, always prefer reg-reg over reg-memory moves.  */
-  if (optimize_size)
+  if (GCC_OPTION (optimize_size))
     return 2;
 
   if (GET_MODE_CLASS (mode) == MODE_INT)
@@ -2326,28 +2326,28 @@ static void
 bfin_option_override (void)
 {
   /* If processor type is not specified, enable all workarounds.  */
-  if (bfin_cpu_type == BFIN_CPU_UNKNOWN)
+  if (GCC_OPTION (bfin_cpu_type) == BFIN_CPU_UNKNOWN)
     {
       int i;
 
       for (i = 0; bfin_cpus[i].name != NULL; i++)
-	bfin_workarounds |= bfin_cpus[i].workarounds;
+	GCC_OPTION (bfin_workarounds) |= bfin_cpus[i].workarounds;
 
-      bfin_si_revision = 0xffff;
+      GCC_OPTION (bfin_si_revision) = 0xffff;
     }
 
-  if (bfin_csync_anomaly == 1)
-    bfin_workarounds |= WA_SPECULATIVE_SYNCS;
-  else if (bfin_csync_anomaly == 0)
-    bfin_workarounds &= ~WA_SPECULATIVE_SYNCS;
+  if (GCC_OPTION (bfin_csync_anomaly) == 1)
+    GCC_OPTION (bfin_workarounds) |= WA_SPECULATIVE_SYNCS;
+  else if (GCC_OPTION (bfin_csync_anomaly) == 0)
+    GCC_OPTION (bfin_workarounds) &= ~WA_SPECULATIVE_SYNCS;
 
-  if (bfin_specld_anomaly == 1)
-    bfin_workarounds |= WA_SPECULATIVE_LOADS;
-  else if (bfin_specld_anomaly == 0)
-    bfin_workarounds &= ~WA_SPECULATIVE_LOADS;
+  if (GCC_OPTION (bfin_specld_anomaly) == 1)
+    GCC_OPTION (bfin_workarounds) |= WA_SPECULATIVE_LOADS;
+  else if (GCC_OPTION (bfin_specld_anomaly) == 0)
+    GCC_OPTION (bfin_workarounds) &= ~WA_SPECULATIVE_LOADS;
 
   if (TARGET_OMIT_LEAF_FRAME_POINTER)
-    flag_omit_frame_pointer = 1;
+    GCC_OPTION (flag_omit_frame_pointer) = 1;
 
 #ifdef SUBTARGET_FDPIC_NOT_SUPPORTED
   if (TARGET_FDPIC)
@@ -2376,10 +2376,10 @@ bfin_option_override (void)
     error ("cannot specify both -msep-data and -mid-shared-library");
   /* ... internally, however, it's nearly the same.  */
   if (TARGET_SEP_DATA)
-    target_flags |= MASK_ID_SHARED_LIBRARY | MASK_LEAF_ID_SHARED_LIBRARY;
+    GCC_OPTION (target_flags) |= MASK_ID_SHARED_LIBRARY | MASK_LEAF_ID_SHARED_LIBRARY;
 
-  if (TARGET_ID_SHARED_LIBRARY && flag_pic == 0)
-    flag_pic = 1;
+  if (TARGET_ID_SHARED_LIBRARY && GCC_OPTION (flag_pic) == 0)
+    GCC_OPTION (flag_pic) = 1;
 
   /* There is no single unaligned SI op for PIC code.  Sometimes we
      need to use ".4byte" and sometimes we need to use ".picptr".
@@ -2389,10 +2389,10 @@ bfin_option_override (void)
 
   /* Silently turn off flag_pic if not doing FDPIC or ID shared libraries,
      since we don't support it and it'll just break.  */
-  if (flag_pic && !TARGET_FDPIC && !TARGET_ID_SHARED_LIBRARY)
-    flag_pic = 0;
+  if (GCC_OPTION (flag_pic) && !TARGET_FDPIC && !TARGET_ID_SHARED_LIBRARY)
+    GCC_OPTION (flag_pic) = 0;
 
-  if (TARGET_MULTICORE && bfin_cpu_type != BFIN_CPU_BF561)
+  if (TARGET_MULTICORE && GCC_OPTION (bfin_cpu_type) != BFIN_CPU_BF561)
     error ("-mmulticore can only be used with BF561");
 
   if (TARGET_COREA && !TARGET_MULTICORE)
@@ -2404,7 +2404,7 @@ bfin_option_override (void)
   if (TARGET_COREA && TARGET_COREB)
     error ("-mcorea and -mcoreb can%'t be used together");
 
-  flag_schedule_insns = 0;
+  GCC_OPTION (flag_schedule_insns) = 0;
 
   init_machine_status = bfin_init_machine_status;
 }
@@ -2640,7 +2640,7 @@ split_load_immediate (rtx operands[])
   if (regno > REG_R7)
     return 0;
 
-  if (optimize_size
+  if (GCC_OPTION (optimize_size)
       && num_compl_zero && shifted_compl >= -64 && shifted_compl <= 63)
     {
       /* If optimizing for size, generate a sequence that has more instructions
@@ -3207,7 +3207,7 @@ bfin_expand_movmem (rtx dst, rtx src, rtx count_exp, rtx align_exp)
     }
 
   /* If optimizing for size, only do single copies inline.  */
-  if (optimize_size)
+  if (GCC_OPTION (optimize_size))
     {
       if (count == 2 && align < 2)
 	return false;
@@ -3377,7 +3377,7 @@ bfin_can_use_doloop_p (double_int, double_int iterations_max,
   /* Due to limitations in the hardware (an initial loop count of 0
      does not loop 2^32 times) we must avoid to generate a hardware
      loops when we cannot rule out this case.  */
-  if (!flag_unsafe_loop_optimizations
+  if (!GCC_OPTION (flag_unsafe_loop_optimizations)
       && (iterations_max.high != 0
 	  || iterations_max.low >= 0xFFFFFFFF))
     return false;
@@ -3408,7 +3408,7 @@ static int
 length_for_loop (rtx insn)
 {
   int length = 0;
-  if (JUMP_P (insn) && any_condjump_p (insn) && !optimize_size)
+  if (JUMP_P (insn) && any_condjump_p (insn) && !GCC_OPTION (optimize_size))
     {
       if (ENABLE_WA_SPECULATIVE_SYNCS)
 	length = 8;
@@ -3896,7 +3896,7 @@ gen_one_bundle (rtx slot[3])
   gcc_assert (slot[1] != NULL_RTX);
 
   /* Don't add extra NOPs if optimizing for size.  */
-  if (optimize_size
+  if (GCC_OPTION (optimize_size)
       && (slot[0] == NULL_RTX || slot[2] == NULL_RTX))
     return false;
 
@@ -4408,7 +4408,7 @@ workaround_speculation (void)
 	  delay_needed -= cycles_since_jump;
 
 	  extract_insn (last_condjump);
-	  if (optimize_size)
+	  if (GCC_OPTION (optimize_size))
 	    {
 	      pat1 = gen_cbranch_predicted_taken (op[0], op[1], op[2],
 						 op[3]);
@@ -4602,7 +4602,7 @@ bfin_reorg (void)
      with old MDEP_REORGS that are not CFG based.  Recompute it now.  */
   compute_bb_for_insn ();
 
-  if (flag_schedule_insns_after_reload)
+  if (GCC_OPTION (flag_schedule_insns_after_reload))
     {
       splitting_for_sched = 1;
       split_all_insns ();
@@ -4611,7 +4611,7 @@ bfin_reorg (void)
       add_sched_insns_for_speculation ();
 
       timevar_push (TV_SCHED2);
-      if (flag_selective_scheduling2
+      if (GCC_OPTION (flag_selective_scheduling2)
 	  && !maybe_skip_selective_scheduling ())
         run_selective_scheduling ();
       else
@@ -4631,7 +4631,7 @@ bfin_reorg (void)
 
   workaround_speculation ();
 
-  if (flag_var_tracking)
+  if (GCC_OPTION (flag_var_tracking))
     {
       timevar_push (TV_VAR_TRACKING);
       variable_tracking_main ();
@@ -4986,7 +4986,7 @@ bfin_output_mi_thunk (FILE *file ATTRIBUTE_UNUSED,
     }
 
   xops[0] = XEXP (DECL_RTL (function), 0);
-  if (1 || !flag_pic || (*targetm.binds_local_p) (function))
+  if (1 || !GCC_OPTION (flag_pic) || (*targetm.binds_local_p) (function))
     output_asm_insn ("jump.l\t%P0", xops);
 }
 
@@ -5696,7 +5696,7 @@ bfin_conditional_register_usage (void)
   bfin_rets_rtx = gen_rtx_REG (Pmode, REG_RETS);
   if (TARGET_FDPIC)
     call_used_regs[FDPIC_REGNO] = 1;
-  if (!TARGET_FDPIC && flag_pic)
+  if (!TARGET_FDPIC && GCC_OPTION (flag_pic))
     {
       fixed_regs[PIC_OFFSET_TABLE_REGNUM] = 1;
       call_used_regs[PIC_OFFSET_TABLE_REGNUM] = 1;
diff --git a/gcc/config/bfin/bfin.h b/gcc/config/bfin/bfin.h
index d6f4c61..b3460c2 100644
--- a/gcc/config/bfin/bfin.h
+++ b/gcc/config/bfin/bfin.h
@@ -40,7 +40,7 @@
       builtin_define ("__ADSPBLACKFIN__");	\
       builtin_define ("__ADSPLPBLACKFIN__");	\
 						\
-      switch (bfin_cpu_type)			\
+      switch (GCC_OPTION (bfin_cpu_type))			\
 	{					\
 	case BFIN_CPU_BF512:			\
 	  builtin_define ("__ADSPBF512__");	\
@@ -145,16 +145,16 @@
 	  break;                \
 	}					\
 						\
-      if (bfin_si_revision != -1)		\
+      if (GCC_OPTION (bfin_si_revision) != -1)		\
 	{					\
 	  /* space of 0xnnnn and a NUL */	\
 	  char *buf = XALLOCAVEC (char, 7);	\
 						\
-	  sprintf (buf, "0x%04x", bfin_si_revision);			\
+	  sprintf (buf, "0x%04x", GCC_OPTION (bfin_si_revision));			\
 	  builtin_define_with_value ("__SILICON_REVISION__", buf, 0);	\
 	}								\
 									\
-      if (bfin_workarounds)						\
+      if (GCC_OPTION (bfin_workarounds))						\
 	builtin_define ("__WORKAROUNDS_ENABLED");			\
       if (ENABLE_WA_SPECULATIVE_LOADS)					\
 	builtin_define ("__WORKAROUND_SPECULATIVE_LOADS");		\
@@ -173,7 +173,7 @@
       if (TARGET_ID_SHARED_LIBRARY		\
 	  && !TARGET_SEP_DATA)			\
 	builtin_define ("__ID_SHARED_LIB__");	\
-      if (flag_no_builtin)			\
+      if (GCC_OPTION (flag_no_builtin))			\
 	builtin_define ("__NO_BUILTIN");	\
       if (TARGET_MULTICORE)			\
 	builtin_define ("__BFIN_MULTICORE");	\
@@ -954,7 +954,7 @@ typedef struct {
      Do not define this macro if it would never modify M.*/
 
 #define BFIN_PROMOTE_MODE_P(MODE) \
-    (!TARGET_DSP && GET_MODE_CLASS (MODE) == MODE_INT	\
+    (!GCC_OPTION (TARGET_DSP) && GET_MODE_CLASS (MODE) == MODE_INT	\
       && GET_MODE_SIZE (MODE) < UNITS_PER_WORD)
 
 #define PROMOTE_MODE(MODE, UNSIGNEDP, TYPE)     \
@@ -976,7 +976,7 @@ typedef struct {
    for the index in the tablejump instruction.  */
 #define CASE_VECTOR_MODE SImode
 
-#define JUMP_TABLES_IN_TEXT_SECTION flag_pic
+#define JUMP_TABLES_IN_TEXT_SECTION GCC_OPTION (flag_pic)
 
 /* Define if operations between registers always perform the operation
    on the full register even if a narrower mode is specified. 
@@ -1108,7 +1108,7 @@ do { 						\
 #define FUNCTION_PROFILER(FILE, LABELNO)	\
   do {						\
     fprintf (FILE, "\t[--SP] = RETS;\n");	\
-    if (TARGET_LONG_CALLS)			\
+    if (GCC_OPTION (TARGET_LONG_CALLS))			\
       {						\
 	fprintf (FILE, "\tP2.h = __mcount;\n");	\
 	fprintf (FILE, "\tP2.l = __mcount;\n");	\
